/******************************************************************************/
/* (c) 2006 jamie twycross, jpt AT cs.nott.ac.uk                              */
/* released under gnu gpl v2                                                  */
/* antigen api                                                                */
/******************************************************************************/

#ifndef ANTIGEN_H
#define ANTIGEN_H

#include <stdio.h>

/* an antigen */
typedef struct {
	int id;  /* antigen identifier */
	unsigned int len;  /* length */
	char *val;  /* value */
} Antigen;

/* function prototypes */
Antigen *init_antigen(const unsigned int);
void free_antigen(Antigen *);
Antigen *read_antigen(FILE *);
void write_antigen(Antigen *, FILE *);
Antigen *dup_antigen(Antigen *);
Antigen *set_antigen(Antigen *, char *);
void set_antigen_fast(Antigen *, char *);
double antigen_match_simple(Antigen *, Antigen *);
double antigen_match_syscall(Antigen *, Antigen *);
double antigen_match_string(Antigen *, Antigen *);
int antigentoi(Antigen *);
long antigentolong(Antigen *);
const char *antigentostr(Antigen *);

#endif
