/******************************************************************************/
/* (c) 2006 jamie twycross, jpt AT cs.nott.ac.uk                              */
/* released under gnu gpl v2                                                  */
/* syscall api - syscall/systrace stuff                                       */
/* some code from neils + marius                                              */
/******************************************************************************/

#ifndef SYSCALL_H
#define SYSCALL_H

#include <sys/time.h>
#include <time.h>
#include <asm/unistd.h>

/* info from a systrace request */
typedef struct {
	struct timeval tm;  /* time of request */
	char process_name[256];
	char process_id[256];
	char policy_name[256];
	char syscall_info[256];
	char filters[256];
	int num_filters;
} Systrace_Request;

/* syscall argument types */
#define SARG_TYPE_0		0  /* # */
#define SARG_TYPE_1		1  /* # + filename */
#define SARG_TYPE_2		2  /* # + pidname */
#define SARG_TYPE_3		3  /* # + fd */
#define SARG_TYPE_4		4  /* # + uid */
#define SARG_TYPE_5		5  /* # + gid */
#define SARG_TYPE_6		6  /* # + gid */

/* function prototypes */
int syscall_number(char *);
char *syscall_name(unsigned int, char *);
int syscall_arg_type(unsigned int);
int systrace_request(char *, Systrace_Request *);
int get_policy_filename(int, char *);

#endif
